signature Parser = sig 

type token =
    T_Public
  | T_System
  | Bar
  | Comma
  | Conditional_begin
  | Conditional_end
  | Conditional_body
  | Dtd_end
  | LBRACK
  | Decl_attlist
  | Decl_element
  | Decl_entity
  | Decl_notation
  | Decl_rangle
  | Doctype
  | Doctype_rangle
  | Dtd_begin
  | Eof
  | Eq
  | Lparen
  | Ignore
  | Implied
  | Percent
  | Pcdata
  | Plus
  | Qmark
  | Rangle
  | Rangle_empty
  | Required
  | Rparen
  | RparenPlus
  | RparenQmark
  | RparenStar
  | Star
  | XMLDecl_begin
  | XMLDecl_end
  | PI_NULL_begin
  | Fixed
  | Attval of (string)
  | Comment of (string)
  | Cdata of (string)
  | CharData of (string)
  | ERef of (string)
  | Name of (string)
  | Nametoken of (string)
  | PERef of (string)
  | Tag_beg of (string)
  | Tag_end of (string)
  | Unparsed_string of (string)
  | Version of (string)
  | Encoding of (string)
  | Standalone of (string)
  | PI_end of (string)
  | PI_begin of (string)
  | CRef of (int)

val ext_parsed_ent :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Nxml_ast.t_entry_point
val ext_pe :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Nxml_ast.t_entry_point
val ext_document :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Nxml_ast.t_entry_point


end (* END of signature Parser *)


structure Parser = struct 

type token =
    T_Public
  | T_System
  | Bar
  | Comma
  | Conditional_begin
  | Conditional_end
  | Conditional_body
  | Dtd_end
  | LBRACK
  | Decl_attlist
  | Decl_element
  | Decl_entity
  | Decl_notation
  | Decl_rangle
  | Doctype
  | Doctype_rangle
  | Dtd_begin
  | Eof
  | Eq
  | Lparen
  | Ignore
  | Implied
  | Percent
  | Pcdata
  | Plus
  | Qmark
  | Rangle
  | Rangle_empty
  | Required
  | Rparen
  | RparenPlus
  | RparenQmark
  | RparenStar
  | Star
  | XMLDecl_begin
  | XMLDecl_end
  | PI_NULL_begin
  | Fixed
  | Attval of (string)
  | Comment of (string)
  | Cdata of (string)
  | CharData of (string)
  | ERef of (string)
  | Name of (string)
  | Nametoken of (string)
  | PERef of (string)
  | Tag_beg of (string)
  | Tag_end of (string)
  | Unparsed_string of (string)
  | Version of (string)
  | Encoding of (string)
  | Standalone of (string)
  | PI_end of (string)
  | PI_begin of (string)
  | CRef of (int)

open Parsing
(* # 2 "parser.ny" *)
(*********************************************************************)
(*                Parser.ny                                          *)	
(*-------------------------------------------------------------------*)
(*  Initiatial development by Eun-sun Cho                            *)
(*  Finalized by Hyun-Goo Kang, ROPAS                                *)
(*-------------------------------------------------------------------*)
(*  http://ropas.kaist.ac.kr/~hgkang                                 *)
(*********************************************************************)

(*****************************************)
(*         To do List : 7/31             *)
(*****************************************)
(*
  - validation  
  - external entity's textdecl
  - more kind of uri, more relative uri
  - Conditional Section : it should be possible in external parameter entity only
  - public literal support 
  - encoding : assumed as ISO-8859/1 (2 byte encoding.. : real challenge)
  - language identifying
*)

open Nxml_ast
open Nxml_errors
open Entity_proccesing
open Notation_processing
open Global

type doc_kind = DT_DOCUMENT 
              | DT_EXT_PARSED_ENT 
              | DT_EXT_PE 

(* Line 36, file parser.n *)
val yytransl_const = [|
  257 (* T_Public *),
  258 (* T_System *),
  259 (* Bar *),
  260 (* Comma *),
  261 (* Conditional_begin *),
  262 (* Conditional_end *),
  263 (* Conditional_body *),
  264 (* Dtd_end *),
  265 (* LBRACK *),
  266 (* Decl_attlist *),
  267 (* Decl_element *),
  268 (* Decl_entity *),
  269 (* Decl_notation *),
  270 (* Decl_rangle *),
  271 (* Doctype *),
  272 (* Doctype_rangle *),
  273 (* Dtd_begin *),
  274 (* Eof *),
  275 (* Eq *),
  276 (* Lparen *),
  277 (* Ignore *),
  278 (* Implied *),
  279 (* Percent *),
  280 (* Pcdata *),
  281 (* Plus *),
  282 (* Qmark *),
  283 (* Rangle *),
  284 (* Rangle_empty *),
  285 (* Required *),
  286 (* Rparen *),
  287 (* RparenPlus *),
  288 (* RparenQmark *),
  289 (* RparenStar *),
  290 (* Star *),
  291 (* XMLDecl_begin *),
  292 (* XMLDecl_end *),
  293 (* PI_NULL_begin *),
  294 (* Fixed *),
    0|]

val yytransl_block = [|
  295 (* Attval *),
  296 (* Comment *),
  297 (* Cdata *),
  298 (* CharData *),
  299 (* ERef *),
  300 (* Name *),
  301 (* Nametoken *),
  302 (* PERef *),
  303 (* Tag_beg *),
  304 (* Tag_end *),
  305 (* Unparsed_string *),
  306 (* Version *),
  307 (* Encoding *),
  308 (* Standalone *),
  309 (* PI_end *),
  310 (* PI_begin *),
  311 (* CRef *),
    0|]

val yylhs = "\255\255\
\051\000\051\000\015\000\016\000\004\000\005\000\006\000\006\000\
\007\000\007\000\008\000\009\000\009\000\010\000\010\000\011\000\
\012\000\012\000\067\000\067\000\013\000\014\000\014\000\014\000\
\017\000\017\000\017\000\017\000\017\000\017\000\018\000\018\000\
\020\000\020\000\020\000\020\000\020\000\020\000\021\000\021\000\
\022\000\022\000\022\000\022\000\024\000\025\000\025\000\023\000\
\023\000\023\000\023\000\023\000\023\000\026\000\027\000\027\000\
\028\000\029\000\029\000\029\000\030\000\030\000\030\000\030\000\
\019\000\019\000\034\000\034\000\035\000\035\000\036\000\036\000\
\036\000\036\000\031\000\031\000\032\000\032\000\040\000\040\000\
\033\000\033\000\033\000\033\000\037\000\037\000\037\000\037\000\
\038\000\041\000\041\000\042\000\043\000\044\000\044\000\044\000\
\045\000\045\000\045\000\045\000\047\000\047\000\046\000\048\000\
\048\000\049\000\050\000\052\000\053\000\053\000\053\000\054\000\
\054\000\055\000\055\000\055\000\056\000\056\000\057\000\058\000\
\058\000\059\000\060\000\061\000\061\000\061\000\061\000\061\000\
\061\000\061\000\061\000\039\000\062\000\062\000\063\000\064\000\
\064\000\065\000\065\000\065\000\065\000\066\000\001\000\002\000\
\003\000\000\000\000\000\000\000"

val yylen = "\002\000\
\002\000\003\000\001\000\001\000\004\000\003\000\000\000\002\000\
\000\000\001\000\005\000\000\000\001\000\000\000\001\000\004\000\
\003\000\001\000\000\000\001\000\003\000\000\000\002\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\004\000\005\000\
\001\000\001\000\001\000\002\000\002\000\002\000\002\000\002\000\
\000\000\001\000\001\000\001\000\003\000\001\000\003\000\002\000\
\002\000\002\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\001\000\002\000\003\000\002\000\003\000\003\000\004\000\
\004\000\005\000\000\000\002\000\003\000\004\000\002\000\003\000\
\004\000\003\000\000\000\003\000\001\000\003\000\001\000\001\000\
\001\000\002\000\003\000\004\000\001\000\001\000\002\000\001\000\
\001\000\003\000\003\000\002\000\003\000\001\000\002\000\002\000\
\001\000\001\000\002\000\002\000\000\000\002\000\001\000\001\000\
\001\000\002\000\003\000\004\000\002\000\002\000\003\000\002\000\
\002\000\000\000\002\000\002\000\001\000\001\000\003\000\000\000\
\004\000\003\000\003\000\000\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\000\000\001\000\004\000\000\000\
\001\000\000\000\002\000\002\000\002\000\005\000\003\000\003\000\
\002\000\002\000\002\000\002\000"

val yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\146\000\124\000\134\000\
\147\000\138\000\000\000\148\000\000\000\114\000\010\000\137\000\
\000\000\000\000\000\000\000\000\120\000\114\000\117\000\118\000\
\124\000\000\000\000\000\143\000\000\000\131\000\129\000\126\000\
\128\000\000\000\127\000\130\000\125\000\000\000\000\000\000\000\
\000\000\000\000\144\000\030\000\003\000\141\000\139\000\025\000\
\026\000\027\000\028\000\029\000\140\000\013\000\000\000\000\000\
\000\000\000\000\000\000\115\000\006\000\114\000\116\000\135\000\
\113\000\112\000\000\000\067\000\004\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\015\000\000\000\123\000\
\119\000\000\000\005\000\000\000\122\000\000\000\000\000\138\000\
\000\000\067\000\000\000\033\000\000\000\000\000\035\000\000\000\
\000\000\034\000\000\000\000\000\000\000\000\000\103\000\000\000\
\092\000\094\000\000\000\104\000\105\000\090\000\091\000\000\000\
\000\000\000\000\011\000\000\000\132\000\000\000\000\000\022\000\
\000\000\020\000\000\000\018\000\000\000\065\000\000\000\000\000\
\068\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\036\000\038\000\037\000\031\000\043\000\
\044\000\042\000\039\000\040\000\000\000\000\000\093\000\097\000\
\098\000\000\000\106\000\095\000\000\000\096\000\000\000\109\000\
\108\000\089\000\121\000\000\000\001\000\000\000\016\000\000\000\
\138\000\142\000\000\000\000\000\000\000\000\000\000\000\066\000\
\000\000\000\000\057\000\000\000\048\000\000\000\000\000\000\000\
\000\000\049\000\000\000\045\000\050\000\000\000\054\000\032\000\
\099\000\100\000\107\000\102\000\111\000\002\000\021\000\024\000\
\023\000\017\000\000\000\080\000\079\000\000\000\000\000\081\000\
\000\000\071\000\000\000\000\000\086\000\085\000\000\000\069\000\
\088\000\000\000\061\000\000\000\059\000\000\000\000\000\051\000\
\052\000\053\000\055\000\047\000\056\000\082\000\000\000\074\000\
\077\000\000\000\000\000\072\000\087\000\070\000\062\000\063\000\
\000\000\060\000\000\000\083\000\000\000\076\000\073\000\064\000\
\084\000\078\000"

val yydgoto = "\004\000\
\006\000\009\000\168\000\012\000\013\000\061\000\014\000\015\000\
\055\000\079\000\062\000\121\000\122\000\166\000\046\000\134\000\
\047\000\048\000\049\000\094\000\095\000\147\000\135\000\136\000\
\137\000\138\000\139\000\098\000\179\000\180\000\210\000\234\000\
\207\000\089\000\129\000\174\000\216\000\217\000\085\000\208\000\
\050\000\075\000\076\000\105\000\151\000\106\000\158\000\107\000\
\108\000\109\000\123\000\051\000\114\000\052\000\026\000\037\000\
\023\000\056\000\024\000\025\000\018\000\007\000\008\000\017\000\
\019\000\053\000\124\000"

val yysindex = "\183\000\
\074\255\074\255\102\255\000\000\023\255\000\000\000\000\000\000\
\000\000\000\000\093\255\000\000\121\255\000\000\000\000\000\000\
\120\255\156\255\085\255\124\255\000\000\000\000\000\000\000\000\
\000\000\016\255\152\255\000\000\183\255\000\000\000\000\000\000\
\000\000\188\255\000\000\000\000\000\000\163\255\239\254\111\255\
\112\255\198\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\207\255\185\255\
\090\255\197\255\218\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\252\255\000\000\000\000\219\255\143\255\221\255\
\222\255\018\255\250\255\253\255\220\255\000\000\232\255\000\000\
\000\000\251\255\000\000\242\255\000\000\214\255\206\255\000\000\
\019\255\000\000\181\255\000\000\061\255\002\000\000\000\094\255\
\094\255\000\000\143\255\018\255\224\255\225\255\000\000\226\255\
\000\000\000\000\227\255\000\000\000\000\000\000\000\000\228\255\
\229\255\006\000\000\000\230\255\000\000\231\255\233\255\000\000\
\009\000\000\000\074\255\000\000\012\255\000\000\158\255\239\255\
\000\000\043\255\189\255\052\255\094\255\114\255\024\000\094\255\
\081\255\094\255\110\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\015\000\037\255\000\000\000\000\
\000\000\237\255\000\000\000\000\244\255\000\000\238\255\000\000\
\000\000\000\000\000\000\240\255\000\000\154\255\000\000\025\000\
\000\000\000\000\210\255\016\000\186\255\131\255\158\255\000\000\
\182\255\003\000\000\000\096\255\000\000\094\255\094\255\094\255\
\189\255\000\000\189\255\000\000\000\000\189\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\136\255\000\000\000\000\213\255\099\255\000\000\
\247\255\000\000\210\255\016\000\000\000\000\000\230\255\000\000\
\000\000\131\255\000\000\254\255\000\000\203\255\004\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\210\255\000\000\
\000\000\103\255\147\255\000\000\000\000\000\000\000\000\000\000\
\255\255\000\000\213\255\000\000\005\000\000\000\000\000\000\000\
\000\000\000\000"

val yyrindex = "\000\000\
\177\255\105\255\000\255\000\000\246\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\230\254\000\000\000\000\000\000\000\000\
\000\000\248\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\008\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\029\000\249\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\032\000\
\032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\033\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\067\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\038\255\000\000\149\255\038\255\
\000\000\038\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\250\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\029\000\
\000\000\000\000\000\000\132\255\000\000\000\000\000\000\000\000\
\000\000\034\000\000\000\000\000\000\000\038\255\038\255\038\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\005\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\132\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

val yygindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\140\000\217\255\
\141\000\000\000\000\000\209\000\216\000\166\255\063\000\191\255\
\000\000\193\255\000\000\217\000\000\000\000\000\099\000\000\000\
\101\000\223\000\000\000\139\000\097\000\142\255\000\000\125\255\
\000\000\000\000\000\000\000\000\000\000\168\255\000\000\165\255\
\000\000\000\000\000\000\000\000\000\000\243\255\245\255\047\001\
\000\000\000\000\000\000\000\000\036\001\001\000\000\000\000\000\
\172\255\000\000\150\000"

val yytablesize = 318
val yytable = "\070\000\
\072\000\163\000\010\000\125\000\036\000\096\000\148\000\097\000\
\153\000\012\000\057\000\152\000\063\000\145\000\009\000\156\000\
\038\000\170\000\101\000\102\000\145\000\039\000\040\000\041\000\
\042\000\012\000\068\000\096\000\069\000\097\000\059\000\093\000\
\126\000\096\000\104\000\097\000\009\000\101\000\102\000\009\000\
\041\000\041\000\181\000\063\000\036\000\186\000\009\000\189\000\
\029\000\128\000\087\000\044\000\029\000\009\000\177\000\060\000\
\176\000\045\000\194\000\093\000\150\000\193\000\127\000\069\000\
\069\000\034\000\103\000\041\000\183\000\034\000\184\000\133\000\
\016\000\063\000\230\000\133\000\133\000\133\000\133\000\133\000\
\091\000\178\000\133\000\187\000\203\000\103\000\127\000\173\000\
\069\000\038\000\128\000\224\000\225\000\226\000\039\000\040\000\
\041\000\042\000\222\000\244\000\237\000\231\000\043\000\133\000\
\140\000\245\000\133\000\083\000\005\000\133\000\188\000\249\000\
\133\000\190\000\133\000\133\000\133\000\133\000\144\000\145\000\
\133\000\029\000\133\000\169\000\044\000\223\000\029\000\146\000\
\232\000\060\000\045\000\206\000\246\000\131\000\073\000\173\000\
\011\000\220\000\034\000\191\000\038\000\133\000\020\000\034\000\
\133\000\039\000\040\000\041\000\042\000\231\000\133\000\046\000\
\213\000\075\000\071\000\074\000\069\000\182\000\133\000\214\000\
\075\000\199\000\091\000\039\000\040\000\041\000\042\000\021\000\
\215\000\075\000\027\000\206\000\029\000\028\000\054\000\044\000\
\247\000\171\000\046\000\162\000\075\000\045\000\241\000\003\000\
\001\000\002\000\092\000\064\000\069\000\034\000\029\000\243\000\
\029\000\044\000\133\000\030\000\031\000\032\000\033\000\045\000\
\131\000\172\000\021\000\069\000\132\000\211\000\067\000\034\000\
\131\000\034\000\035\000\080\000\081\000\133\000\118\000\119\000\
\133\000\133\000\133\000\133\000\112\000\113\000\120\000\133\000\
\133\000\219\000\069\000\069\000\082\000\212\000\133\000\133\000\
\133\000\029\000\069\000\065\000\030\000\031\000\032\000\033\000\
\066\000\077\000\029\000\021\000\084\000\060\000\240\000\227\000\
\069\000\228\000\034\000\035\000\229\000\204\000\205\000\069\000\
\204\000\205\000\078\000\034\000\088\000\086\000\090\000\110\000\
\099\000\100\000\111\000\115\000\117\000\116\000\157\000\143\000\
\154\000\155\000\103\000\161\000\159\000\160\000\162\000\164\000\
\167\000\165\000\175\000\185\000\192\000\195\000\197\000\196\000\
\198\000\120\000\233\000\209\000\221\000\242\000\007\000\008\000\
\136\000\239\000\248\000\014\000\019\000\041\000\101\000\058\000\
\250\000\200\000\201\000\149\000\141\000\142\000\236\000\235\000\
\130\000\218\000\238\000\022\000\058\000\202\000"

val yycheck = "\039\000\
\040\000\116\000\002\000\088\000\018\000\071\000\097\000\071\000\
\100\000\036\001\022\000\100\000\026\000\009\001\015\001\104\000\
\005\001\006\001\001\001\002\001\016\001\010\001\011\001\012\001\
\013\001\052\001\044\001\093\000\046\001\093\000\015\001\071\000\
\014\001\099\000\074\000\099\000\037\001\001\001\002\001\040\001\
\003\001\004\001\133\000\057\000\058\000\136\000\047\001\138\000\
\037\001\089\000\062\000\040\001\037\001\054\001\003\001\040\001\
\014\001\046\001\150\000\099\000\100\000\150\000\044\001\046\001\
\046\001\054\001\049\001\030\001\134\000\054\001\134\000\005\001\
\050\001\087\000\206\000\009\001\010\001\011\001\012\001\013\001\
\020\001\030\001\016\001\003\001\169\000\049\001\044\001\127\000\
\046\001\005\001\130\000\182\000\183\000\184\000\010\001\011\001\
\012\001\013\001\003\001\231\000\215\000\003\001\018\001\037\001\
\044\001\003\001\040\001\018\001\035\001\005\001\030\001\243\000\
\046\001\004\001\010\001\011\001\012\001\013\001\025\001\026\001\
\054\001\037\001\018\001\123\000\040\001\030\001\037\001\034\001\
\030\001\040\001\046\001\171\000\030\001\020\001\023\001\175\000\
\035\001\177\000\054\001\030\001\005\001\037\001\050\001\054\001\
\040\001\010\001\011\001\012\001\013\001\003\001\046\001\003\001\
\022\001\022\001\044\001\044\001\046\001\044\001\054\001\029\001\
\029\001\008\001\020\001\010\001\011\001\012\001\013\001\047\001\
\038\001\038\001\051\001\211\000\037\001\018\001\051\001\040\001\
\030\001\020\001\030\001\049\001\049\001\046\001\222\000\001\000\
\002\000\003\000\044\001\036\001\046\001\054\001\037\001\231\000\
\037\001\040\001\018\001\040\001\041\001\042\001\043\001\046\001\
\020\001\044\001\047\001\046\001\024\001\020\001\044\001\054\001\
\020\001\054\001\055\001\027\001\028\001\037\001\001\001\002\001\
\040\001\041\001\042\001\043\001\001\001\002\001\009\001\047\001\
\044\001\044\001\046\001\046\001\044\001\044\001\054\001\055\001\
\044\001\037\001\046\001\053\001\040\001\041\001\042\001\043\001\
\053\001\044\001\037\001\047\001\048\001\040\001\044\001\185\000\
\046\001\187\000\054\001\055\001\190\000\044\001\045\001\046\001\
\044\001\045\001\052\001\054\001\009\001\044\001\044\001\014\001\
\044\001\044\001\014\001\036\001\027\001\019\001\044\001\014\001\
\049\001\049\001\049\001\014\001\049\001\049\001\049\001\049\001\
\016\001\049\001\044\001\004\001\014\001\049\001\049\001\044\001\
\049\001\009\001\044\001\020\001\034\001\034\001\047\001\047\001\
\051\001\044\001\044\001\036\001\016\001\014\001\014\001\014\001\
\044\001\166\000\166\000\099\000\093\000\093\000\212\000\211\000\
\090\000\175\000\218\000\013\000\025\000\168\000"

val yyact = [|
  (fn _ => failwith "parser")
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 137 "parser.ny" *)
         
        let 
          val s = a_2
          val external_id = SYSTEM(s)
          val absolute_uri = System_Processing.absolute_path (current_URI()) s 
          val _ = push_a_URI(absolute_uri)
          val str = System_Processing.string_from_system_literal(absolute_uri)
          val new_lexbuf = Lexing.from_string str                  
        in                 
          push_a_lexbuf(new_lexbuf, true, !line_no);
          external_id
        end
       ) : t_external_id)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 151 "parser.ny" *)
         
        let 
          val s = a_3
          val external_id = PUBLIC(a_2,s)
          val absolute_uri = System_Processing.absolute_path (current_URI()) s 
          val _ = push_a_URI(absolute_uri)
          val str = System_Processing.string_from_system_literal(absolute_uri)
          val new_lexbuf = Lexing.from_string str                  
        in 
          push_a_lexbuf(new_lexbuf, true, !line_no);
          external_id
        end
       ) : t_external_id)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 166 "parser.ny" *)
    
	    // external parsed pe + internal parsed pe
            // (this production shouldn't appear in inner part of markupdecl)
	  let  	    
	    val p_entity = pe_entity_env_lookup a_1	    
	    val is_external = pe_is_external p_entity
	    val _ = if (is_external) then 
	            let val uri = pe_get_uri(p_entity)
	            in  if (!Global.debug_tag) then 
	                   print_string ("pushing a uri "^uri);
	                push_a_URI(uri) 
	            end	        
	    val the_string = pe_extract_string p_entity	    
	    val _ = Global.current_URI()
	    val new_lexbuf = Lexing.from_string the_string
	  in push_a_lexbuf(new_lexbuf, (pe_is_external(p_entity)), !line_no) end
          ) : unit)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 185 "parser.ny" *)
           
            // only for internal parsed pe
            // (it can appear in inner part of markupdecl production as long as it can be parsed properly)
	  let  	    
	    val p_entity = pe_entity_env_lookup a_1
	    val _ = if (pe_is_external p_entity) then 
	            raise XMLParserError(
	                    Other_errors("an external pe ref can't appear in inner part of"
	                             ^ " markupdecl production",!line_no))	            
	    val the_string = pe_extract_string p_entity	    
	    val new_lexbuf = Lexing.from_string the_string
	  in 
	     if (!Global.debug_tag) then 
	        print_string "pushing a internal pe";
	     push_a_lexbuf(new_lexbuf,false, !line_no) 
	  end            
	  ) : unit)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : t_prolog) in
	let val a_2 = (peek_val parser_env 2 : t_element) in
	let val a_3 = (peek_val parser_env 1 : t_misc list) in
	Obj.repr((
(* # 210 "parser.ny" *)
                                            DOCUMENT(a_1, a_2,List.rev(a_3)) ) : Nxml_ast.t_entry_point)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_opt_xml_decl) in
	let val a_2 = (peek_val parser_env 1 : t_misc list) in
	let val a_3 = (peek_val parser_env 0 : t_opt_doctype_decl_miscs) in
	Obj.repr((
(* # 214 "parser.ny" *)
   (a_1, List.rev(a_2), a_3) ) : t_prolog)  end  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 217 "parser.ny" *)
          EMPTY_ODTDM ) : t_opt_doctype_decl_miscs) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_doctype_decl) in
	let val a_2 = (peek_val parser_env 0 : t_misc list) in
	Obj.repr((
(* # 219 "parser.ny" *)
   ODTDM(a_1, List.rev(a_2))) : t_opt_doctype_decl_miscs)  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 222 "parser.ny" *)
         EMPTY_XML_DECL) : t_opt_xml_decl) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_opt_xml_decl) in
	Obj.repr((
(* # 223 "parser.ny" *)
             a_1) : t_opt_xml_decl)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 3 : string) in
	let val a_3 = (peek_val parser_env 2 : t_opt_encoding) in
	let val a_4 = (peek_val parser_env 1 : t_opt_standalone) in
	Obj.repr((
(* # 227 "parser.ny" *)
  XML_DECL (VERSION(a_2), a_3, a_4)) : t_opt_xml_decl)  end  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 230 "parser.ny" *)
                     EMPTY_ENCODING) : t_opt_encoding) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 231 "parser.ny" *)
             ENCODING(a_1)) : t_opt_encoding)  end )
, (fn parser_env =>
	Obj.repr((
(* # 234 "parser.ny" *)
               EMPTY_STANDALONE ) : t_opt_standalone) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 236 "parser.ny" *)
   	case a_1 of 
			"yes" => YES_STANDALONE
                      | "no" => NO_STANDALONE 
		      | _ => raise XMLParserError(Illegal(a_1, 
					"stand alone parameter",!line_no,"")) 
	) : t_opt_standalone)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_3 = (peek_val parser_env 1 : t_opt_external_id * t_opt_internal_decl_list) in
	Obj.repr((
(* # 245 "parser.ny" *)
   (a_2, fst a_3, snd a_3) ) : t_doctype_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_external_id) in
	let val a_2 = (peek_val parser_env 1 : Nxml_ast.t_entry_point) in
	let val a_3 = peek_val parser_env 0 in
	Obj.repr((
(* # 248 "parser.ny" *)
                                                    (EXTERNALID(a_1,a_2), a_3)) : t_opt_external_id * t_opt_internal_decl_list)  end  end  end )
, (fn parser_env =>
	let val a_1 = peek_val parser_env 0 in
	Obj.repr((
(* # 249 "parser.ny" *)
                           (EMPTY_EXTERNALID,a_1)) : t_opt_external_id * t_opt_internal_decl_list)  end )
, (fn parser_env =>
	Obj.repr((
(* # 251 "parser.ny" *)
                     EMPTY_INTERNAL_DECL)))
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_internal_decl_body list) in
	Obj.repr((
(* # 252 "parser.ny" *)
                  INTERNAL_DECL_LIST(a_1))) end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : t_internal_decl_body list) in
	Obj.repr((
(* # 255 "parser.ny" *)
  
	List.rev(a_2)
	) : t_internal_decl_body list)  end )
, (fn parser_env =>
	Obj.repr((
(* # 259 "parser.ny" *)
                           nil) : t_internal_decl_body list) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_internal_decl_body list) in
	let val a_2 = (peek_val parser_env 0 : t_markup_decl) in
	Obj.repr((
(* # 260 "parser.ny" *)
                                        MARKUP(a_2)::a_1) : t_internal_decl_body list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_internal_decl_body list) in
	let val a_2 = (peek_val parser_env 0 : unit) in
	Obj.repr((
(* # 261 "parser.ny" *)
                                    a_1) : t_internal_decl_body list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_markup_decl) in
	Obj.repr((
(* # 265 "parser.ny" *)
                  a_1) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_markup_decl) in
	Obj.repr((
(* # 266 "parser.ny" *)
                  a_1) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_entity_decl) in
	Obj.repr((
(* # 267 "parser.ny" *)
                 ENTITY_DECL(a_1)) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string * t_post_notation_decl) in
	Obj.repr((
(* # 268 "parser.ny" *)
                   NOTATION_DECL(a_1) ) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_pi) in
	Obj.repr((
(* # 269 "parser.ny" *)
           PI_MARKUP(a_1) ) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 270 "parser.ny" *)
              COMMENT_MARKUP(a_1)) : t_markup_decl)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_3 = (peek_val parser_env 1 : t_content_spec) in
	Obj.repr((
(* # 274 "parser.ny" *)
  ELEMENT_DECL (a_2, a_3)) : t_markup_decl)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 3 : unit) in
	let val a_3 = (peek_val parser_env 2 : string) in
	let val a_4 = (peek_val parser_env 1 : t_content_spec) in
	Obj.repr((
(* # 276 "parser.ny" *)
  ELEMENT_DECL (a_3, a_4)) : t_markup_decl)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 280 "parser.ny" *)
   case a_1 of 
		"EMPTY" => EMPTY_CS
		| "ANY" => ANY_CS 
		| _ => raise XMLParserError(Illegal(a_1, "content spec",!line_no,"")) ) : t_content_spec)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_mixed) in
	Obj.repr((
(* # 284 "parser.ny" *)
                   MIXED(a_1)) : t_content_spec)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_pre_children * t_marks) in
	Obj.repr((
(* # 285 "parser.ny" *)
                          CHILDREN(a_1)) : t_content_spec)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 287 "parser.ny" *)
   case a_2 of 
		"EMPTY" => EMPTY_CS
		| "ANY" => ANY_CS 
		| _ => raise XMLParserError(Illegal(a_2, "content spec",!line_no,"")) ) : t_content_spec)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : t_mixed) in
	Obj.repr((
(* # 291 "parser.ny" *)
                           MIXED(a_2)) : t_content_spec)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : t_pre_children * t_marks) in
	Obj.repr((
(* # 292 "parser.ny" *)
                       CHILDREN(a_2)) : t_content_spec)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_cp list) in
	let val a_2 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 295 "parser.ny" *)
                                     (CHOICE(a_1),a_2)) : t_pre_children * t_marks)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_cp list) in
	let val a_2 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 296 "parser.ny" *)
                            (SEQ(a_1),a_2)) : t_pre_children * t_marks)  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 298 "parser.ny" *)
                    NO_MARK) : t_marks) )
, (fn parser_env =>
	Obj.repr((
(* # 299 "parser.ny" *)
          STAR) : t_marks) )
, (fn parser_env =>
	Obj.repr((
(* # 300 "parser.ny" *)
          PLUS) : t_marks) )
, (fn parser_env =>
	Obj.repr((
(* # 301 "parser.ny" *)
          QMARK) : t_marks) )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : t_cp list) in
	Obj.repr((
(* # 305 "parser.ny" *)
  List.rev(a_2)) : t_cp list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_cp) in
	Obj.repr((
(* # 307 "parser.ny" *)
                   a_1::nil) : t_cp list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_cp list) in
	let val a_3 = (peek_val parser_env 0 : t_cp) in
	Obj.repr((
(* # 308 "parser.ny" *)
                        a_3::a_1) : t_cp list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	let val a_2 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 311 "parser.ny" *)
                              (NAME_CP(a_1),a_2)) : t_cp)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_cp list) in
	let val a_2 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 312 "parser.ny" *)
                             (CHOICE_CP(a_1),a_2) ) : t_cp)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_cp list) in
	let val a_2 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 313 "parser.ny" *)
                           (SEQ_CP(a_1), a_2)) : t_cp)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : unit) in
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 315 "parser.ny" *)
                                    (NAME_CP(a_2),a_3)) : t_cp)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : unit) in
	let val a_2 = (peek_val parser_env 1 : t_cp list) in
	let val a_3 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 316 "parser.ny" *)
                                      (CHOICE_CP(a_2),a_3) ) : t_cp)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : unit) in
	let val a_2 = (peek_val parser_env 1 : t_cp list) in
	let val a_3 = (peek_val parser_env 0 : t_marks) in
	Obj.repr((
(* # 317 "parser.ny" *)
                                      (SEQ_CP(a_2),a_3) ) : t_cp)  end  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : t_cp list) in
	Obj.repr((
(* # 321 "parser.ny" *)
                              List.rev(a_2)) : t_cp list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_cp) in
	let val a_3 = (peek_val parser_env 0 : t_cp) in
	Obj.repr((
(* # 323 "parser.ny" *)
                        
		// According to the original XML definition, 
		// this rule must be consist of only 'cp', instead of 'cp Comma cp'.
		// However it raises a reduce-reduce conflict with 'choice_body' rule.
		// In order to avoid this problem 
		// I changed 'seq_body' to have at least two cp's 
		a_3::a_1::nil
	) : t_cp list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_cp list) in
	let val a_3 = (peek_val parser_env 0 : t_cp) in
	Obj.repr((
(* # 331 "parser.ny" *)
                       a_3::a_1) : t_cp list)  end  end )
, (fn parser_env =>
	let val a_3 = (peek_val parser_env 0 : t_mixed) in
	Obj.repr((
(* # 335 "parser.ny" *)
          
          let 
            fun duplicate_name_check([]) = false
	      | duplicate_name_check(id::tl) = 
	         (List.exists (fn(id')=>(id'=id)) tl) 
	         || duplicate_name_check(tl)
	  in
	    (case a_3 of 
	        MIXED_ONLY => a_3
	      | MIXED_STAR(l) => 
	        if (duplicate_name_check l) then 
	          raise XMLParserError(Other_errors("No Duplicate Types: "
	          	        ^ " The same name must not appear more than once "
	        	        ^ "in a single mixed context decl",!line_no))
	        else
	          a_3)
	  end        	        
        ) : t_mixed)  end )
, (fn parser_env =>
	Obj.repr((
(* # 354 "parser.ny" *)
                      MIXED_ONLY ) : t_mixed) )
, (fn parser_env =>
	Obj.repr((
(* # 355 "parser.ny" *)
                   MIXED_STAR (nil) ) : t_mixed) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string list) in
	Obj.repr((
(* # 356 "parser.ny" *)
                                 MIXED_STAR(List.rev(a_1))) : t_mixed)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 358 "parser.ny" *)
                              a_2::nil) : string list)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : unit) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 359 "parser.ny" *)
                               a_3::nil) : string list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string list) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 360 "parser.ny" *)
                                     a_3::a_1) : string list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : string list) in
	let val a_3 = (peek_val parser_env 1 : unit) in
	let val a_4 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 361 "parser.ny" *)
                                       a_4::a_1) : string list)  end  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_3 = (peek_val parser_env 1 : (string * t_att_type * t_default_decl) list) in
	Obj.repr((
(* # 365 "parser.ny" *)
         ATTLIST_DECL(a_2,List.rev(a_3))) : t_markup_decl)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 3 : unit) in
	let val a_3 = (peek_val parser_env 2 : string) in
	let val a_4 = (peek_val parser_env 1 : (string * t_att_type * t_default_decl) list) in
	Obj.repr((
(* # 367 "parser.ny" *)
         ATTLIST_DECL((a_3),List.rev(a_4))) : t_markup_decl)  end  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 369 "parser.ny" *)
                 nil) : (string * t_att_type * t_default_decl) list) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : (string * t_att_type * t_default_decl) list) in
	let val a_2 = (peek_val parser_env 0 : string * t_att_type * t_default_decl) in
	Obj.repr((
(* # 370 "parser.ny" *)
                                      a_2::a_1) : (string * t_att_type * t_default_decl) list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string) in
	let val a_2 = (peek_val parser_env 1 : t_att_type) in
	let val a_3 = (peek_val parser_env 0 : t_default_decl) in
	Obj.repr((
(* # 373 "parser.ny" *)
                                      (a_1,a_2,a_3)) : string * t_att_type * t_default_decl)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : unit) in
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_3 = (peek_val parser_env 1 : t_att_type) in
	let val a_4 = (peek_val parser_env 0 : t_default_decl) in
	Obj.repr((
(* # 374 "parser.ny" *)
                                               (a_2,a_3,a_4)) : string * t_att_type * t_default_decl)  end  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	let val a_2 = (peek_val parser_env 0 : string list) in
	Obj.repr((
(* # 386 "parser.ny" *)
  
	  case a_2 of 
	    nil => 
	      (case a_1 of 
		 "CDATA" => CDATA
	       | "ID" => ID // this is value uniquely idenify the elements which bear them
	       | "IDREF" => IDREF
	       | "IDREFS" => IDREFS
	       | "ENTITY" => ENTITY
	       | "ENTITIES" => ENTITIES
	       | "NMTOKEN" => NMTOKEN
	       | "NMTOKENS" => NMTOKENS
	       | _ => raise XMLParserError(Illegal(a_1, "type name",!line_no,
		"The name should be one of the CDATA/ID/IDREF(S)/ENTITY(S)/NMTOKEN(S)")) 
	       )
	   | a::alist => 
	       (case a_1 of 
	          "NOTATION" => NOTATION(a::alist)
	       | _  => raise XMLParserError(Illegal(a_1, "type name",!line_no,"illgal notation type"))
	       )  
	) : t_att_type)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : unit) in
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : string list) in
	Obj.repr((
(* # 408 "parser.ny" *)
  
	  case a_3 of 
	    nil => 
	      (case a_2 of 
		 "CDATA" => CDATA
	       | "ID" => ID // this is value uniquely idenify the elements which bear them
	       | "IDREF" => IDREF
	       | "IDREFS" => IDREFS
	       | "ENTITY" => ENTITY
	       | "ENTITIES" => ENTITIES
	       | "NMTOKEN" => NMTOKEN
	       | "NMTOKENS" => NMTOKENS
	       | _ => raise XMLParserError(Illegal(a_2, "type name",!line_no,
		"The name should be one of the CDATA/ID/IDREF(S)/ENTITY(S)/NMTOKEN(S)")) 
	       )
	   | a::alist => 
	       (case a_2 of 
	          "NOTATION" => NOTATION(a::alist)
	       | _  => raise XMLParserError(Illegal(a_2, "type name",!line_no,"illgal notation type"))
	       )  	   
	) : t_att_type)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : unit) in
	let val a_3 = (peek_val parser_env 1 : string list) in
	Obj.repr((
(* # 430 "parser.ny" *)
   ENUMERATION(List.rev(a_3)) ) : t_att_type)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string list) in
	Obj.repr((
(* # 432 "parser.ny" *)
   ENUMERATION(List.rev(a_2)) ) : t_att_type)  end )
, (fn parser_env =>
	Obj.repr((
(* # 434 "parser.ny" *)
                     nil) : string list) )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string list) in
	Obj.repr((
(* # 435 "parser.ny" *)
                                      List.rev(a_2)) : string list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 440 "parser.ny" *)
          if (notation_exists a_1) then
             a_1::nil
          else   
             raise XMLParserError(
	           Other_errors("undefined notation reference in Notation Attributes: "
	                         ^ a_1,!line_no))
        ) : string list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string list) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 448 "parser.ny" *)
   if (notation_exists a_3) then
             a_3::a_1
          else   
             raise XMLParserError(
	           Other_errors("undefined notation reference in Notation Attributes: "
	                         ^ a_3,!line_no))
        ) : string list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 457 "parser.ny" *)
                        a_1) : string)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 458 "parser.ny" *)
         a_1 
		(* Name is introduced for Nametoken because 'Name' is subset  of 'Nametoken'
		and the lexer returns 'Name' instead of 'Nametoken' when it matches 'Name' *) ) : string)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 463 "parser.ny" *)
                                a_1::nil) : string list)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 464 "parser.ny" *)
                         a_2::nil) : string list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string list) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 465 "parser.ny" *)
                                    a_3::a_1) : string list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : string list) in
	let val a_3 = (peek_val parser_env 1 : unit) in
	let val a_4 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 466 "parser.ny" *)
                                             a_4::a_1) : string list)  end  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 469 "parser.ny" *)
                           REQUIRED) : t_default_decl) )
, (fn parser_env =>
	Obj.repr((
(* # 470 "parser.ny" *)
                IMPLIED) : t_default_decl) )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 471 "parser.ny" *)
                      FIXED(a_2)) : t_default_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 472 "parser.ny" *)
                 ATTVALUE(a_1)) : t_default_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 475 "parser.ny" *)
                              normalize_attr_value(a_1) ) : string)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : t_entity_decl) in
	Obj.repr((
(* # 478 "parser.ny" *)
                                                  a_2) : t_entity_decl)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : t_entity_decl) in
	Obj.repr((
(* # 479 "parser.ny" *)
                                                   a_2) : t_entity_decl)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	let val a_2 = (peek_val parser_env 0 : t_entity_def) in
	Obj.repr((
(* # 483 "parser.ny" *)
         
         let 
           val ge_def = a_2         
         in 
           (case ge_def of 
             GSTR_VAL(val_str) => ge_entity_env_insert a_1 (G_STR(val_str))
           | EXTERNAL_GENT(SYSTEM(s),EMPTY_NDATA) =>  
               ge_entity_env_insert a_1 (G_REF(SYSTEM_REF(s),EMPTY_NOTATION))
           | EXTERNAL_GENT(SYSTEM(s),NDATA(ndata)) =>  
               if (notation_exists ndata) then
                 ge_entity_env_insert a_1 (G_REF(SYSTEM_REF(s),N(ndata)))
               else
                 raise XMLParserError(
	                 Other_errors("undefined notation reference in ge definition: "
	                             ^ ndata,!line_no))
           | EXTERNAL_GENT(PUBLIC(s1,s2),EMPTY_NDATA) => 
               ge_entity_env_insert a_1 (G_REF(PUBLIC_REF(s1,s2),EMPTY_NOTATION))
           | EXTERNAL_GENT(PUBLIC(s1,s2),NDATA(ndata)) =>
               if (notation_exists ndata) then
                 ge_entity_env_insert a_1 (G_REF(PUBLIC_REF(s1,s2),N(ndata)))
               else
                 raise XMLParserError(
	                 Other_errors("undefined notation reference in ge definition: "
	                             ^ ndata,!line_no))
           );
            GEDECL(a_1,a_2)
          end                  
        ) : t_entity_decl)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : t_pe_def) in
	Obj.repr((
(* # 514 "parser.ny" *)
         
         let val pe_def = a_3
         in 
           (case pe_def of 
             PSTR_VAL(val_str) => 
               pe_entity_env_insert a_2 (P_STR(val_str))
           | EXTERNAL_PENT(SYSTEM(s)) => 
               pe_entity_env_insert a_2 (P_REF(SYSTEM_REF(s)))
           | EXTERNAL_PENT(PUBLIC(s1,s2)) => 
               pe_entity_env_insert a_2  (P_REF(PUBLIC_REF(s1,s2)))
            );
            PEDECL(a_2,a_3)
          end  
         ) : t_entity_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 531 "parser.ny" *)
                          GSTR_VAL(a_1)) : t_entity_def)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 532 "parser.ny" *)
                                 GSTR_VAL(a_2)) : t_entity_def)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_external_id) in
	let val a_2 = (peek_val parser_env 0 : t_opt_ndata) in
	Obj.repr((
(* # 533 "parser.ny" *)
                           EXTERNAL_GENT(a_1,a_2)) : t_entity_def)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 536 "parser.ny" *)
                         PSTR_VAL(a_1)) : t_pe_def)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_external_id) in
	Obj.repr((
(* # 537 "parser.ny" *)
                       EXTERNAL_PENT(a_1)) : t_pe_def)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 538 "parser.ny" *)
                                 PSTR_VAL(a_2)) : t_pe_def)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : unit) in
	let val a_2 = (peek_val parser_env 0 : t_external_id) in
	Obj.repr((
(* # 539 "parser.ny" *)
                               EXTERNAL_PENT(a_2)) : t_pe_def)  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 542 "parser.ny" *)
             EMPTY_NDATA) : t_opt_ndata) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 544 "parser.ny" *)
   if (a_1 = "NDATA") then NDATA(a_2)
		else  raise XMLParserError(Illegal(a_1, "NDataDecl", 
			!line_no, "keyword 'NDATA' is expected" )) ) : t_opt_ndata)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 549 "parser.ny" *)
                                normalize_entity_value(a_1)) : string)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_external_id) in
	Obj.repr((
(* # 556 "parser.ny" *)
                     a_1) : t_external_id)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_external_id) in
	Obj.repr((
(* # 556 "parser.ny" *)
                                               a_1) : t_external_id)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 560 "parser.ny" *)
  
	  SYSTEM(a_2)
	) : t_external_id)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 565 "parser.ny" *)
                                             // first unparsed should be a public char seq
		 PUBLIC(a_2,a_3)
		) : t_external_id)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_3 = (peek_val parser_env 1 : t_post_notation_decl) in
	Obj.repr((
(* # 572 "parser.ny" *)
         
          let 
            val n_body = a_3
          in
            (case n_body of 
                EXTERNAL_ID_NOTATION(SYSTEM(s)) => 
                   notation_env_insert a_2 (N_SYSTEM s) 
              | EXTERNAL_ID_NOTATION(PUBLIC(s1,s2)) =>
                   notation_env_insert a_2 (N_PUBLIC(s1,s2))
              | PUBID(s) =>
                   notation_env_insert a_2 (N_PUB s));
            (a_2, a_3)
          end  
        ) : string * t_post_notation_decl)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 588 "parser.ny" *)
                           EXTERNAL_ID_NOTATION(SYSTEM(a_2))) : t_post_notation_decl)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 589 "parser.ny" *)
                                  PUBID(a_2)) : t_post_notation_decl)  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 1 : string) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 590 "parser.ny" *)
                                                   EXTERNAL_ID_NOTATION(PUBLIC(a_2,a_3))) : t_post_notation_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 593 "parser.ny" *)
                        PI_WITH_TARGET(a_1,a_2)) : t_pi)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 594 "parser.ny" *)
                          PI_WO_TARGET(a_2)) : t_pi)  end )
, (fn parser_env =>
	Obj.repr((
(* # 597 "parser.ny" *)
            nil) : t_misc list) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_misc list) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 598 "parser.ny" *)
                  COMMENT(a_2)::a_1) : t_misc list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_misc list) in
	let val a_2 = (peek_val parser_env 0 : t_pi) in
	Obj.repr((
(* # 599 "parser.ny" *)
               PI(a_2)::a_1) : t_misc list)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string * ((string *string) list)) in
	Obj.repr((
(* # 602 "parser.ny" *)
                               EMPTY_ELEMENT_TAG(a_1)) : t_element)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 :  string * ((string * string) list) * t_content list * string) in
	Obj.repr((
(* # 603 "parser.ny" *)
                   FULL_ELEMENT(a_1)) : t_element)  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string) in
	let val a_2 = (peek_val parser_env 1 : (string *string) list) in
	Obj.repr((
(* # 607 "parser.ny" *)
                                                          (a_1,List.rev(a_2))) : string * ((string *string) list))  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 609 "parser.ny" *)
                         nil) : (string *string) list) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 3 : (string *string) list) in
	let val a_2 = (peek_val parser_env 2 : string) in
	let val a_4 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 610 "parser.ny" *)
                                     (a_2, a_4)::a_1) : (string *string) list)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string * ((string * string) list )) in
	let val a_2 = (peek_val parser_env 1 : t_content list ) in
	let val a_3 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 618 "parser.ny" *)
   if ((fst a_1) = a_3) then (fst a_1, snd a_1,List.rev(a_2), a_3)
		else raise XMLParserError(TagMismatch(fst a_1, a_3, !line_no)  ) ) :  string * ((string * string) list) * t_content list * string)  end  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : string) in
	let val a_2 = (peek_val parser_env 1 : (string *string) list) in
	Obj.repr((
(* # 623 "parser.ny" *)
      
	      let 
	        val l = List.rev(a_2)
	        fun duplicate_att_name_check([]) = false
	          | duplicate_att_name_check((id,att_val)::tl) = 
	            (List.exists (fn(id',_)=>(id'=id)) tl) 
	            || duplicate_att_name_check(tl)
	               
	        val _ = if (duplicate_att_name_check l) then 
	        	raise XMLParserError(Other_errors("Unique Att spec:"
	        	      ^ " no attibutename may appear more than once"
	        	      ^ " in the same start-tag or empty_element tag",!line_no))
	      in 
	      	(a_1,l)
	      end
	    ) : string * ((string * string) list ))  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 641 "parser.ny" *)
            nil) : t_content list ) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : t_element) in
	Obj.repr((
(* # 642 "parser.ny" *)
                     (ELEMENT_CNT a_2)::a_1) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 643 "parser.ny" *)
                      (CHARDATA_CNT a_2)::a_1) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : int) in
	Obj.repr((
(* # 645 "parser.ny" *)
  
	  let 
	    val num = a_2
	  in
            if (num > 255) then // fix
              (print_string ("Warning: this processor don't support 2 byte character(num_str="^(string_of_int num)^")\n");
               print_string ("         substituting it to ?\n");
               CHARDATA_CNT("?")::a_1)               
            else  
              CHARDATA_CNT(String.make 1 (Char.chr(num)))::a_1
	  end
	) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 658 "parser.ny" *)
   let
	    val g_entity = ge_entity_env_lookup a_2
	  in
	    if (ge_is_unparsed g_entity) then
	      raise XMLParserError(
	             Other_errors("unparsed entity ref is forbidden in contents",!line_no))
	    else
	    let
              val is_external = ge_is_external g_entity
	      val _ = if (is_external) then 
	              let val uri = ge_get_uri(g_entity)
	              in push_a_URI(uri) end	         
	      val the_string =  ge_extract_string(g_entity)
	      // ⼭ external̸ textdecl 
	      //  Ʈ Եȴ.
	      val new_lexbuf = Lexing.from_string (the_string)
	    in
	      push_a_lexbuf(new_lexbuf,is_external,!line_no);
	      a_1  // so EREF_CNT can't exist in absyn
	    end
	    // for external parsed entity : the ruls is "included if validating"
	    // for i didn't implemete validation yet, i always included it. 
	    // if there is any error you meet just a exception
	  end  
	 ) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 683 "parser.ny" *)
                    (CDATA_CNT a_2)::a_1) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : t_pi) in
	Obj.repr((
(* # 684 "parser.ny" *)
                 (PI_CNT a_2)::a_1 ) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_content list ) in
	let val a_2 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 685 "parser.ny" *)
                     (COMMENT_CNT a_2)::a_1) : t_content list )  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : string) in
	Obj.repr((
(* # 688 "parser.ny" *)
                          a_1) : string)  end )
, (fn parser_env =>
	Obj.repr((
(* # 690 "parser.ny" *)
                 EMPTY_TEXTDECL) : t_opt_text_decl ) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : t_opt_text_decl ) in
	Obj.repr((
(* # 691 "parser.ny" *)
             a_1) : t_opt_text_decl )  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 2 : t_opt_version ) in
	let val a_3 = (peek_val parser_env 1 : string) in
	Obj.repr((
(* # 695 "parser.ny" *)
   case a_2 of
		EMPTY_VERSION => TEXTDECL(a_3) 
		| VERSION t => TEXTDECL_WITHVERSION(t,a_3) 
	) : t_opt_text_decl )  end  end )
, (fn parser_env =>
	Obj.repr((
(* # 700 "parser.ny" *)
               EMPTY_VERSION) : t_opt_version ) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 0 : string) in
	Obj.repr((
(* # 700 "parser.ny" *)
                                       VERSION(a_1)) : t_opt_version )  end )
, (fn parser_env =>
	Obj.repr((
(* # 703 "parser.ny" *)
                   nil) : t_ext_subset_decl) )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_ext_subset_decl) in
	let val a_2 = (peek_val parser_env 0 : t_markup_decl) in
	Obj.repr((
(* # 705 "parser.ny" *)
   MARKUP_EXT(a_2)::a_1) : t_ext_subset_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_ext_subset_decl) in
	let val a_2 = (peek_val parser_env 0 : t_include * t_ext_subset_decl) in
	Obj.repr((
(* # 707 "parser.ny" *)
   CONDITIONALSECT(a_2)::a_1) : t_ext_subset_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_ext_subset_decl) in
	let val a_2 = (peek_val parser_env 0 : unit) in
	Obj.repr((
(* # 708 "parser.ny" *)
                             a_1) : t_ext_subset_decl)  end  end )
, (fn parser_env =>
	let val a_2 = (peek_val parser_env 3 : string) in
	let val a_4 = (peek_val parser_env 1 : t_ext_subset_decl) in
	Obj.repr((
(* # 712 "parser.ny" *)
          case  a_2 of
	  "INCLUDE" => (INCLUDE, a_4)
	| "IGNORE" => (IGNORE, a_4)
	| _ => raise XMLParserError(Illegal(a_2, "conditional section declaration",
	      !line_no,  ": any keyword except INCLUDE or IGNORE is disallowed" )) ) : t_include * t_ext_subset_decl)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_opt_text_decl ) in
	let val a_2 = (peek_val parser_env 1 : t_content list ) in
	Obj.repr((
(* # 724 "parser.ny" *)
   EXT_PARSEDENT(a_1,List.rev(a_2)) ) : Nxml_ast.t_entry_point)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 2 : t_opt_text_decl ) in
	let val a_2 = (peek_val parser_env 1 : t_ext_subset_decl) in
	Obj.repr((
(* # 731 "parser.ny" *)
  EXT_PE(a_1,List.rev(a_2))) : Nxml_ast.t_entry_point)  end  end )
, (fn parser_env =>
	let val a_1 = (peek_val parser_env 1 : t_opt_text_decl ) in
	let val a_2 = (peek_val parser_env 0 : t_ext_subset_decl) in
	Obj.repr((
(* # 733 "parser.ny" *)
  EXT_PE(a_1,List.rev(a_2))) : Nxml_ast.t_entry_point)  end  end )
(* Entry ext_parsed_ent *)
, (fn parser_env => raise (YYexit (peek_val parser_env 0)))
(* Entry ext_pe *)
, (fn parser_env => raise (YYexit (peek_val parser_env 0)))
(* Entry ext_document *)
, (fn parser_env => raise (YYexit (peek_val parser_env 0)))
|]
val yytables =
  { actions=yyact,
    transl_const=yytransl_const,
    transl_block=yytransl_block,
    lhs=yylhs,
    len=yylen,
    defred=yydefred,
    dgoto=yydgoto,
    sindex=yysindex,
    rindex=yyrindex,
    gindex=yygindex,
    tablesize=yytablesize,
    table=yytable,
    check=yycheck,
    error_function=parse_error }
fun ext_parsed_ent (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 2 lexfun lexbuf : Nxml_ast.t_entry_point)
fun ext_pe (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 3 lexfun lexbuf : Nxml_ast.t_entry_point)
fun ext_document (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Nxml_ast.t_entry_point)
(* Line 736, file parser.ny *)

(*********************************************************)
(*                 Trailer Section                       *)
(*********************************************************)

(*---------------------------------------------------------*)
(*          Wrappers for each start_symbol(parser)         *)
(*---------------------------------------------------------*)
(* entry points of parser 				 					*)
(* wrapped with handling the parser_error with line number 	*)
(* {78} extParsedEnt *)
fun extParsedEnt f b = (ext_parsed_ent f b ) 
	handle Parse_error =>  raise XMLParserError(Other_errors("Syntax error in parsed entity ", !line_no )) 
	| x  => raise x
(* {79} extPE *)
fun extPE  f b = (ext_pe f b )
	handle Parse_error =>  raise XMLParserError(Other_errors("Syntax error in external parameter entities", !line_no )) 
	| x  => raise x
(* {01} document *)
fun document  f b = (ext_document  f b) 
	handle Parse_error =>  raise XMLParserError(Other_errors("Syntax error in external document", !line_no )) 
	| x  => raise x

(*
// main parser function 
fun parse lexfun uri option = let  
  val absolute= System_Processing.absolute_path (Global.current_URI()) uri
  val _ = Global.push_a_URI absolute 
  val ducument_string = System_Processing.string_from_system_literal absolute // it's normalized
  val lexbuf = Lexing.from_string ducument_string
in 
  case option of 
    DT_DOCUMENT => document lexfun lexbuf
  | DT_EXT_PARSED_ENT => extParsedEnt lexfun lexbuf
  | DT_EXT_PE => extPE lexfun lexbuf
end
*)

(*---------------------------------------------------------*)
(*          Pretty Printer for Debugging                   *)
(*---------------------------------------------------------*)
(* print each token for debugging *)
fun print_tok tok = 
(	case tok of
    Bar => print_string "(|)"
  | Comma => print_string "(,)"
  | T_System => print_string "SYSTEM"  
  | T_Public => print_string "PUBLIC"
  | Conditional_begin => print_string "(Conditional_begin)"
  | Conditional_end => print_string "(Conditional_end)"
  | Conditional_body => print_string "(Conditional_body)"
  | LBRACK => print_string "([)"
  | Dtd_end => print_string "(Dtd_end)"
  | Decl_attlist => print_string "(Decl_attlist)"
  | Decl_element => print_string "(Decl_element)"
  | Decl_entity => print_string "(Decl_entity)"
  | Decl_notation => print_string "(Decl_notation)"
  | Decl_rangle => print_string "(Decl_rangle)"
  | Doctype => print_string "(Doctype)"
  | Doctype_rangle => print_string "(Doctype_rangle)"
  | Dtd_begin => print_string "(Dtd_begin)"
  | Eof => print_string "(Eof)"
  | Eq => print_string "(Eq)"
  | Lparen => print_string "(Lparen)"
  | Ignore => print_string "(Ignore)"
  | Implied => print_string "(Implied)"
  | Percent => print_string "(Percent)"
  | Pcdata => print_string "(Pcdata)"
  | Plus => print_string "(Plus)"
  | Qmark => print_string "(Qmark)"
  | Rangle => print_string "(Rangle)"
  | Rangle_empty => print_string "(Rangle_empty)"
  | Required => print_string "(Required)"
  | Rparen => print_string "(Rparen)"
  | RparenPlus => print_string "(RparenPlus)"
  | RparenQmark => print_string "(RparenQmark)"
  | RparenStar => print_string "(RparenStar)"
  | Star => print_string "(Star)"
  | XMLDecl_begin => print_string "(XMLDecl_begin)"
  | XMLDecl_end => print_string "(XMLDecl_end)"
  | Fixed => print_string "(Fixed)"
  | Attval t => print_string ("(Attval:"^t^")")
  | Comment t =>  print_string ("(Comment:"^t^")")
  | Cdata  t => print_string ("(Cdata:"^t^")")
  | CharData  t => print_string ("(CharData:"^t^")")
  | ERef t =>print_string ("(ERef:"^t^")")
  | Name t => print_string ("(Name:"^t^")")
  | Nametoken t => print_string ("(Nametoken:"^t^")")
  | PERef t => print_string ("(PERef:"^t^")")
  | Tag_beg t => print_string ("(Tag_beg:"^t^")")
  | Tag_end t => print_string ("(Tag_end:"^t^")")
  | Unparsed_string t => print_string ("(Unparsed_string:"^t^")")
  | Version t => print_string ("(Version:"^t^")")
  | Encoding t => print_string ("(Encoding:"^t^")")
  | Standalone t => print_string ("(Standalone:"^t^")")
  | PI_end t => print_string ("(PI_end:"^t^")")
  | PI_begin t => print_string ("(PI_begin:"^t^")")
  | PI_NULL_begin => print_string ("(PI_NULL_begin)")
  | CRef t => (print_string "(CRef:"; print_int t; print_string ")")
)
(* Line 1471, file parser.n *)


end (* END of structure Parser *)
