(*********************************************************************)
(*                validate.n                                         *)	
(*-------------------------------------------------------------------*)
(*  by Hyun-Goo Kang                                                 *)
(*-------------------------------------------------------------------*)
(*  Implement validation of xml document using given absyn           *)
(*-------------------------------------------------------------------*)
(*  To do                                                            *)
(*-------------------------------------------------------------------*)
(*  - I just implemented stucture of validation                      *)
(*  - It's not completed                                             *)
(*********************************************************************)


structure NDOM = 
struct

open Nxml_ast  

type t_document_error = INDEX_SIZE_ERR   //= 1;
	| DOMSTRING_SIZE_ERR             //= 2;
	| HIERARCHY_REQUEST_ERR          //= 3;
	| WRONG_DOCUMENT_ERR             //= 4;
	| INVALID_CHARACTER_ERR          //= 5;
	| NO_DATA_ALLOWED_ERR            //= 6;
	| NO_MODIFICATION_ALLOWED_ERR    //= 7;
	| NOT_FOUND_ERR                  //= 8;
	| NOT_SUPPORTED_ERR              //= 9;
	| INUSE_ATTRIBUTE_ERR            //= 10;
	//--------Introduced in DOM Level 2:--------
	| INVALID_STATE_ERR              //= 11;
	| SYNTAX_ERR                     //= 12;
	| INVALID_MODIFICATION_ERR       //= 13;
	| NAMESPACE_ERR                  //= 14;
	| INVALID_ACCESS_ERR             //= 15;
exception DOMException of t_document_error

val xml_decl = {version = ref "1.0", encoding = ref "ISO-8859/1", standalone = ref EMPTY_STANDALONE }
val root_name = ref ""

val pi_env = ref []
val comments = ref []

fun set_version(ver) = xml_decl.version := ver
fun get_version() = !(xml_decl.version)
fun set_encoding(enc) = xml_decl.encoding := enc
fun get_encoding() = !(xml_decl.encoding)
fun set_standalone(s) = xml_decl.standalone := s
fun get_standalone() = !(xml_decl.standalone)
fun set_root_name(s) = root_name := s
fun get_root_name() = !root_name

fun insert_PI(target,instruction) = pi_env := (target,instruction)::(!pi_env)
fun lookup_PI(target) = let 
  val (_,instruction) = (List.find (fn(id,instr) => (id = target)) (!pi_env)) 
  			handle Not_found => raise DOMException(NOT_FOUND_ERR)
in
  instruction
end

fun insert_comment(s) = comments := s::(!comments)
fun get_comments(s) = !comments

(*
fun createElement(in DOMString tagName) = raises(DOMException)
fun createDocumentFragment() = 
fun createTextNode(in DOMString data) =
fun createComment(in DOMString data) = 
fun createCDATASection(in DOMString data) = raises(DOMException)  
fun createProcessingInstruction(in DOMString target, in DOMString data) = raises(DOMException)
fun createAttribute(in DOMString name) = raises(DOMException)
fun createEntityReference(in DOMString name) = raises(DOMException)
fun getElementsByTagName(in DOMString tagname) = 

// Introduced in DOM Level 2:
fun importNode(in Node importedNode, in boolean deep) =  raises(DOMException)
fun createElementNS(in DOMString namespaceURI, in DOMString qualifiedName) = raises(DOMException)
fun createAttributeNS(in DOMString namespaceURI, in DOMString qualifiedName) = raises(DOMException)
fun getElementsByTagNameNS(in DOMString namespaceURI, in DOMString localName) =
fun getElementById(in DOMString elementId) = 
*)

end


structure Validate =
struct

open Nxml_ast
open NDOM
exception VC of string  

//type document_env = (xml_decl * misc_list * doctype_decl_miscsprolog


fun env_doctype_decl(name,ext_id,int_decl_l) = let
  val _ = set_root_name(name)
in
(*	
   (case ext_id of 
       EMPTY_EXTERNALID =>
     | EXTERNALID(e_id) => 
    );
   (case int_decl_l of 
       EMPTY_INTERNAL_DECL =>
     | INTERNAL_DECL_LIST(l) => 
    ); 
*)    
  ()      
end


fun add_PI(PI_WITH_TARGET(target,instruction)) = insert_PI(target,instruction)
  | add_PI(PI_WO_TARGET(target)) = insert_PI(target,"")
fun env_miscs([]) = ()
  | env_miscs(PI(pi)::tl) = add_PI(pi)
  | env_miscs(COMMENT(s)::tl) = insert_comment(s)

fun mk_envorinment(xml_decl, misc_list,doctype_decl_miscsprolog) = let
  fun env_xml_decl(EMPTY_XML_DECL) = set_version("1.0")
    | env_xml_decl(XML_DECL(ver, enc, standalone)) = 
        (case ver of 
          (EMPTY_VERSION | VERSION("1.0")) => set_version("1.0")
          | VERSION(s) => raise VC("version " ^ s ^ " is not acceptable"));
        (case enc of  
          (EMPTY_ENCODING | ENCODING("ISO-8859/1")) => set_encoding("ISO-8859/1")
          | _ => print_string ("Warning: This XML parser support only ISO-8859/1 encoding\n")
                 //raise VC("This XML parser support only ISO-8859/1 encoding")
         );
        set_standalone(standalone)
in
  env_xml_decl(xml_decl);
  env_miscs(misc_list);
  (case doctype_decl_miscsprolog of 
     EMPTY_ODTDM => ()
   | ODTDM(doctype_decl,misc_list)=>
       env_doctype_decl(doctype_decl);
       env_miscs(misc_list))		
end
  
fun validate(DOCUMENT(prolog,element,misc_list)) = let 
  val dtd = mk_envorinment(prolog)
  val _ = env_miscs(misc_list)
  // if problematic, raise exception 
  fun vc_root_element_type(EMPTY_ELEMENT_TAG(ename,att_val_list)) = ()
    | vc_root_element_type(FULL_ELEMENT(ename1,att_val_list,c_list,ename2)) = 
        if not (ename1 = get_root_name()) then raise VC("invalid root element name: " ^ ename1)
in
  vc_root_element_type(element)
end    
  | validate(EXT_PARSEDENT(text_decl,content_list)) = ()
  | validate(EXT_PE(text_decl,ext_subset_decl)) = ()
end